/********************************************************* begin of preamble
**
** Copyright (C) 2003-2010 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
package com.sos.scheduler.engine.kernel.order;

import com.sos.scheduler.engine.kernel.log.PrefixLog;
import com.sos.scheduler.engine.kernel.variable.UnmodifiableVariableSet;
import com.sos.scheduler.engine.kernel.scheduler.Platform;
import com.sos.scheduler.engine.kernel.log.SchedulerLogger;
import com.sos.scheduler.engine.kernel.order.jobchain.UnmodifiableJobchain;

public class UnmodifiableOrderDelegate implements UnmodifiableOrder {
    private final UnmodifiableOrder order;

    public UnmodifiableOrderDelegate(UnmodifiableOrder order) {
        this.order = order;
    }

    @Override public OrderKey getKey() {
        return order.getKey();
    }

    @Override public OrderId getId() {
        return order.getId();
    }

    @Override public OrderState getState() {
        return order.getState();
    }

    @Override public OrderState getEndState() {
        return order.getEndState();
    }

    @Override public String getTitle() {
        return order.getTitle();
    }

    @Override public UnmodifiableJobchain getJobChain() {
        return order.getJobChain();
    }

    @Override public UnmodifiableJobchain getJobChainOrNull() {
        return order.getJobChainOrNull();  //TODO Delegate erzeugen
    }

    @Override public UnmodifiableVariableSet getParameters() {
        return order.getParameters();   // TODO Delegate erzeugen
    }

    @Override public PrefixLog getLog() {
        return order.getLog();
    }

    @Override public Platform getPlatform() {
        return order.getPlatform();
    }

    @Override public SchedulerLogger log() {
        return order.log();
    }

    @Override public String toString() {
        return order.toString();
    }
}
