/********************************************************* begin of preamble
**
** Copyright (C) 2003-2010 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
package com.sos.scheduler.model.objects;

import java.util.Calendar;
import java.util.Date;

import org.apache.log4j.Logger;

import com.sos.JSHelper.DataElements.JSDataElementDate;
import com.sos.JSHelper.DataElements.JSDateFormat;
import com.sos.VirtualFileSystem.Interfaces.ISOSVirtualFile;
import com.sos.scheduler.model.SchedulerObjectFactory;
import com.sos.scheduler.model.objects.Holidays.Weekdays.Day;

/**
* \class JSObjHolidays 
* 
* \brief JSObjHolidays - 
* 
* \details
*
* \section JSObjHolidays.java_intro_sec Introduction
*
* \section JSObjHolidays.java_samples Some Samples
*
* \code
*   .... code goes here ...
* \endcode
*
* <p style="text-align:center">
* <br />---------------------------------------------------------------------------
* <br /> APL/Software GmbH - Berlin
* <br />##### generated by ClaviusXPress (http://www.sos-berlin.com) #########
* <br />---------------------------------------------------------------------------
* </p>
* \author oh
* @version $Id$
* \see reference
*
* Created on 08.02.2011 12:03:17
 */

/**
 * @author oh
 *
 */
public class JSObjHolidays extends Holidays {

	@SuppressWarnings("unused")
	private final String		conClassName	= "JSObjHolidays";
	@SuppressWarnings("unused")
	private static final Logger	logger			= Logger.getLogger(JSObjHolidays.class);

	public JSObjHolidays(SchedulerObjectFactory schedulerObjectFactory) {
		super();
		objFactory = schedulerObjectFactory;
	}

	public JSObjHolidays(SchedulerObjectFactory schedulerObjectFactory, ISOSVirtualFile pobjVirtualFile) {
		this(schedulerObjectFactory);
		Holidays objHolidays = (Holidays) unMarshal(pobjVirtualFile);
		setObjectFieldsFrom(objHolidays);
		setHotFolderSrc(pobjVirtualFile);
	}

	public boolean isAHoliday(final Calendar pobjCalendar) {
	
	@SuppressWarnings("unused")
	final String	conMethodName	= conClassName + "::isAHoliday";
	
	return isAHoliday(pobjCalendar.getTime());
} // private boolean isAHoliday

	public boolean isAHoliday(Date pobjDate) {

		@SuppressWarnings("unused")
		final String conMethodName = conClassName + "::isAHoliday";

		boolean flgIsAHoliday = false;
		Calendar cal = Calendar.getInstance();
		cal.setFirstDayOfWeek(Calendar.MONDAY);
		cal.setTime(pobjDate);
		int intDayOfWeek = cal.get(Calendar.DAY_OF_WEEK);
		intDayOfWeek -= 1;
		if (intDayOfWeek == 0) {
			intDayOfWeek = 7;
		}
		
		for (Object objO : this.getWeekdaysOrHolidayOrInclude()) {
			if (objO instanceof Weekdays) {
				Weekdays objW = (Weekdays) objO;
				for (Day objDay : objW.day) {
					for (String strD : objDay.day) {
//						logger.info("day = " + strD);
						if (intDayOfWeek == new Integer(strD)) {
							flgIsAHoliday = true;
							return flgIsAHoliday;
						}
					}
				}
			}
		}

		for (Object objO : this.getWeekdaysOrHolidayOrInclude()) {
			if (objO instanceof Holiday) {
				Holiday objH = (Holiday) objO;
				String strD = objH.getDate();
				Date objD = new JSDataElementDate(strD, JSDateFormat.dfDATE_SHORT).getDateObject();
//				long l1 = objD.getTime();
//				long l2 = pobjDate.getTime();
//				System.out.println("l1 = " + l1 + ", l2 = " + l2);
				if (objD.equals(pobjDate)) {
					flgIsAHoliday = true;
					return flgIsAHoliday;
				}
			}
		}

		for (Object objO : this.getWeekdaysOrHolidayOrInclude()) {
			if (objO instanceof Include) {

			}
		}

		return flgIsAHoliday;
	} // private boolean isAHoliday

}
