/********************************************************* begin of preamble
**
** Copyright (C) 2003-2010 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
/* wprtfile.h                                           (c) SOS GmbH Berlin
                                                            Joacim Zschimmer
*/

#ifndef __WPRTFILE_H
#define __WPRTFILE_H

#if !defined( __SV_HXX )
#   include <sv.hxx>
#endif

#include <absfile.h>




struct Print_file : Abs_record_file
{
                Print_file      () {};
              //Print_file      ( const char* filename, Open_mode ) {};
               ~Print_file      () {};

    static const Abs_file_type& static_file_type();
    static Sos_ptr<Print_file>  create();

    void        open            ( const char* filename, Open_mode, const File_spec& ) {};
    void        close           ( Close_mode = close_normal ) {};
    void        flush           () {};

  protected:
    virtual void put_record     ( const Const_area& ) {};
    virtual void write_area     ( const Const_area& ) {};
    virtual void read_area      ( Area& ) {};

  private:
    void        _init           ();

    Point               _position;
    int                 _left_margin;
    Bool                _opened                : 1;
    Bool                _opened_by_constructor : 1;
};


struct Fontwidth_file : Abs_file
{
                        Fontwidth_file      () { _init(); };
                      //Fontwidth_file      ( const char* filename, Open_mode, const File_spec& );
                       ~Fontwidth_file      () {};

    void                open                ( const char* filename, Open_mode, const File_spec& );

  protected:
    virtual void        get_record_key      ( Area&, const Key& );
  //virtual Record_length       key_length              ( Key::Number = 0 );

  private:
    void                _init();
  //Record_length       _key_length;
};

#endif
