/********************************************************* begin of preamble
**
** Copyright (C) 2003-2010 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
#include "precomp.h"
//#define MODULE_NAME "sossv2"
/* sossv2.cpp                                            (c) SOS GmbH Berlin
                                                            Joacim Zschimmer

Hilfsfunktionen, implementiert mit StarView. Ohne Sos_application.
Versuch, alle Aufrufe von StarView hier und in sossv.cpp zu konzentrieren, so da alle
anderen Module frei von StarView sind.

*/
#include "../kram/sosstrng.h"
#include "../kram/sysdep.h"

#undef cerr   // sysdep.h soll cerr nur fr win16 sperren

#if defined SYSTEM_STARVIEWxxxxxxx
#   include <sv.hxx>
#elif defined SYSTEM_WIN
#   include <windows.h>
#endif

#include "../kram/sos.h"
//#include "../kram/sossv.h"
#include "../kram/log.h"

using namespace std;
namespace sos {

Bool sos_gui = true;   // Wird von sosmain.cxx = false gesetzt

extern Sos_string   module_filename();

//--------------------------------------------------------------------show_msg()

#if 0
typedef void (* _RTLENTRY new_handler)() /* throw(xalloc) */;

new_handler _RTLENTRY set_new_handler(new_handler);
#endif

typedef void (* Msg_func)( const char* text );

static Msg_func _msg_function = NULL;

void set_show_msg_function( Msg_func f )
{
    _msg_function = f;
}

extern void show_msg( const char* text_ptr )
{
    LOGI( "SHOW_MSG( \"" << text_ptr << "\" )\n" );

    if ( _msg_function != NULL ) {
        (*_msg_function)( text_ptr );
        return;
    }

#   if defined SYSTEM_STARVIEWxxxxxx
        if( InSendMessage() ) {
            LOG( "in SendMessage()!\n" );
        } else {
            ErrorBox( NULL, WB_OK, text_ptr ).Execute();
        }
#   elif defined SYSTEM_WIN
        if( sos_gui ) {
            if( InSendMessage() ) {
                LOG( "in SendMessage()!\n" );
            } else {
                Sos_string m;
                Sos_string text;

                try {
                    Sos_string mod = module_filename();
                    //LOG( "mod=" << mod << "\n" );
                    const char* p = c_str( mod ) + length( mod );
                    const char* q = p;
                    while( p > c_str( mod )  &&  p[-1] != '/'  &&  p[-1] != '\\'  &&  p[-1] != ':' )  p--;
                    while( q > p  &&  q[-1] != '.' )  q--;
                    if( q > p )  q--;  // '.'
                    m = as_string( p, q - p );
                    //LOG( "m=" << m << "\n" );
                    if( q == p )  m = "SOS";
                    //LOG( "m=" << m << "\n" );
                }
                catch( const Xc& )
                {
                    m = "SOS";
                }

                // MessageBox bricht nur an Blanks um. Also Blanks einfgen:

                {
                    const char* p = text_ptr;
                    int         n = 0;

                    while( *p ) {
                        //LOG( "*p=" << *p << ", n=" << n << "\n" );
                        text += *p++;
                        if( *p == ' ' || *p == '\n' )  n = 0;
                                                 else  n++;
                        if( n >= 50 ) {
                            text += ' ';
                            n = 0;
                        }
                    }
                }

                //LOG( "text=" << text << ", m=" << m << "\n" );

                MessageBox( 0/*hwndParent*/, c_str( text ), c_str( m )/*caption*/, MB_TASKMODAL /*| MB_ICONINFORMATION*/ );
            }
        }
        else
        {
            cerr << text_ptr << '\n';
        }
#   else
        cerr << text_ptr << '\n';
#   endif
}


} //namespace sos
