/********************************************************* begin of preamble
**
** Copyright (C) 2003-2010 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
#define MODULE_NAME "video"
// video.cpp
//                                                      (c) Joacim Zschimmer
#if 0

#pragma hdrstop

#include <stdlib.h>
#include <string.h>

#if defined __BORLANDC__
    //#include <memory.h>
#   include <conio.h>
#   include <bios.h>    // biosequip
#endif

#include <sos.h>
#include <sosstore.h>
#include "video.h"

//------------------------------------------------------Video_pos::object_store

void Video_pos::object_store( Sos_output_store& s )
{
    s.write_int1( _offset / video_line_length );
    s.write_int1( _offset % video_line_length );
}

//-------------------------------------------------------Video_pos::object_load

Video_pos& Video_pos::object_load( Sos_input_store& s )
{
    _offset = s.read_int1();
    _offset = _offset * video_line_length + s.read_int1();
    return *this;
}

//----------------------------------------------------------------------operator <<

ostream& operator << ( ostream& s, Video_pos pos )
{
    return s << '(' << pos.column0() << ',' << pos.line0() << ')';
}

//------------------------------------------------------------Video::set_cursor

void Video::set_cursor( Video_pos pos ) {
#   ifdef __BORLANDC__
        gotoxy( 1 + pos.column0(), 1 + pos.line0() );
#    else
        REGS r;
        r.h.ah = 0x02;
        r.h.bh = 0;
        r.h.dh = pos.line0();
        r.h.dl = pos.column0();
        int86( 10, &r, &r );
#   endif
}

//-----------------------------------------------------------------Video::write

void Video::write(
    Video_pos   pos, 
    char*       text, 
    int         len, 
    Video_attr  attr 
)
{
    set_cursor( pos );
    while (len--)  write( pos++, *text++, attr );
}

//------------------------------------------------------------------Video::fill

void Video::fill(
    Video_pos   pos, 
    char        c,
    int         len,
    Video_attr  attr 
)
{
    char filler [ video_line_length ];

    memset( filler, c, sizeof filler );

    while( len > 0 ) {
        int l = min( len, video_line_length - pos.column0() );
        write( pos, filler, l, attr );
        len -= l;
        pos = pos.offset() + l;
    }

    //? set_cursor( pos );
    //while (len--)  write( pos++, c, attr );
}

//---------------------------------------------------------------------------------Video::scroll_up

void Video::scroll_up( int oben, int unten, int anzahl )
{
    move( oben, oben + anzahl, unten - oben + 1 - anzahl );
}

//-------------------------------------------------------------------------------Video::scroll_down

void Video::scroll_down( int oben, int unten, int anzahl )
{
    move( oben + anzahl, oben, unten - oben + 1 - anzahl );
}

//--------------------------------------------------------------------------------------Video::sync

void Video::sync()
{
}

#endif
