/********************************************************* begin of preamble
**
** Copyright (C) 2003-2010 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
#include <precomp.h>
#define MODULE_NAME "videowi2"
//                                                    (c) SOS GmbH Berlin
//                                                        Jrg Schwiemann

#if 0

#define SOURCE "videowi2.cpp"
#include <videowin.h>
#include <memory.h>

void VideoWin::_init() {
      Font aFont( "Fixedsys", Size( 0, 15 ) );
      aFont.ChangeCharSet( CHARSET_ANSI );
      aFont.ChangeFamily( FAMILY_MODERN );
      aFont.ChangePitch( PITCH_FIXED );
      aFont.ChangeWeight ( WEIGHT_NORMAL );
      aFont.ChangeAlign( ALIGN_TOP );

      //Font aFont( ResId( FONT_COURIER ) );
      aFont.ChangeSize( Size( 0, 15 ) );
      String aStr; 
      aStr.Fill( video_line_length ); // zur Berechnung der Font-Breite
      ChangeFont( aFont );
      aFontSize = Size( GetTextSize( aStr ).Width() / video_line_length,
                        aFont.GetSize().Height() );
      aScreenSize = Size( aFontSize.Width() * video_line_length,               
                          video_line_count * aFontSize.Height() + _LineOffset );
      ChangeOutputSizePixel( aScreenSize );
      //Maximize();

};

void VideoWin::write( Video_pos pos, char c, Video_attr ) {
       aVideoBuffer[pos.offset()] = c;
       DrawText( Point( pos.column0() * FontSize().Width(),
                        pos.line0() * FontSize().Height() + _LineOffset ),
                 String( c ) );
};

void VideoWin::write( Video_pos pos, char *text, int len, Video_attr ) {
       memcpy( aVideoBuffer+pos.offset(), text, len );
       char buf[video_line_length+1];
       memcpy( buf, text, len );
       buf[len] = 0;
       DrawText( Point( pos.column0() * FontSize().Width(),
                        pos.line0() * FontSize().Height() + _LineOffset ),
                 String( buf ) );
};


void VideoWin::Paint( const Rectangle& ) {
// Rectangle => Berechnung der betroffenen Zeilen und Spalten!
       char buf[video_line_length+1];
       buf[video_line_length] = 0;
       int aHeight = FontSize().Height();

       for ( int i = 0; i < video_line_count; i++ ) {
         memcpy( buf, aVideoBuffer + ( i * video_line_length ),
                 video_line_length );
         DrawText( Point( 0, i * aHeight + _LineOffset), buf );
       };

 };

void VideoWin::move (
        Subrange< int, 0, video_line_count >  ziel_zeilennr,
        Subrange< int, 0, video_line_count >  quell_zeilennr,
        Subrange< int, 0, video_line_count >  zeilenanz )  
{
    memmove( aVideoBuffer + ziel_zeilennr  * video_line_length,
             aVideoBuffer + quell_zeilennr * video_line_length,
             zeilenanz * video_line_length );
    //InvalidateForeground( Rectangle& );
};


void VideoWin::ScrollUpLine( Subrange< int, 0, video_line_count > anz ) {
   Scroll( 0, - anz * FontSize().Height() );
   scroll_up( anz, video_line_count-1, anz );
   // Loeschen der restliche Zeilen;
   for ( int i = video_line_count - anz; i < video_line_count; i++ ) {
     aVideoBuffer[i*video_line_length] = 0;
   };
};

#endif

